
if (GetLocale() == "enUS" or GetLocale() == "enGB") then
	-- equip and set bonus prefixes:
	HEALPOINTSBS_PREFIX_EQUIP = "Equip: ";
	HEALPOINTSBS_PREFIX_SET = "Set: ";
	
	-- passive bonus patterns. checked against lines which start with above prefixes
	HEALPOINTSBS_PATTERNS_PASSIVE = {
		{ pattern = "Improves your chance to get a critical strike with spells by (%d+)%%%.", effect = "SPELLCRIT" },
		{ pattern = "Improves your chance to get a critical strike with Holy spells by (%d+)%%%.", effect = "HOLYCRIT" },
		{ pattern = "Increases the critical effect chance of your Holy spells by (%d+)%%%.", effect = "HOLYCRIT" },
		{ pattern = "Increases healing done by spells and effects by up to (%d+)%.", effect = "HEAL" },
		{ pattern = "Increases damage and healing done by magical spells and effects by up to (%d+)%.", effect = "HEAL" },
		{ pattern = "Restores (%d+) mana per 5 sec%.", effect = "MANAREG" },
		{ pattern = "Restores (%d+) mana every 5 sec%.", effect = "MANAREG" },
	
		-- Added
		{ pattern = "Allows (%d+)%% of your Mana regeneration to continue while casting%.", effect = "CASTINGREG"},		
		{ pattern = "Improves your chance to get a critical strike with Nature spells by (%d+)%%%.", effect = "NATURECRIT"}, 
		{ pattern = "Reduces the casting time of your Regrowth spell by 0%.(%d+) sec%.", effect = "CASTINGREGROWTH"}, 
		{ pattern = "Reduces the casting time of your Holy Light spell by 0%.(%d+) sec%.", effect = "CASTINGHOLYLIGHT"},
    { pattern = "Reduces the casting time of your Healing Touch spell by 0%.(%d+) sec%.", effect = "CASTINGHEALINGTOUCH"},
    { pattern = "%-0%.(%d+) sec to the casting time of your Flash Heal spell%.", effect = "CASTINGFLASHHEAL"},
		{ pattern = "%-0%.(%d+) seconds on the casting time of your Chain Heal spell%.", effect = "CASTINGCHAINHEAL"},
		{ pattern = "Increases the duration of your Rejuvenation spell by (%d+) sec%.", effect = "DURATIONREJUV"},
		{ pattern = "Increases the duration of your Renew spell by (%d+) sec%.", effect = "DURATIONRENEW"},
		{ pattern = "Increases your normal health and mana regeneration by (%d+)%.", effect = "MANAREGNORMAL"},
		{ pattern = "Increases the amount healed by Chain Heal to targets beyond the first by (%d+)%%%.", effect = "IMPCHAINHEAL"},
    { pattern = "Increases healing done by Rejuvenation by up to (%d+)%.", effect = "IMPREJUVENATION"},
    { pattern = "Increases healing done by Lesser Healing Wave by up to (%d+)%.", effect = "IMPLESSERHEALINGWAVE"}
  };
	
	-- generic patterns have the form "+xx bonus" or "bonus +xx" with an optional % sign after the value.
	
	-- first the generic bonus string is looked up in the following table
	HEALPOINTSBS_PATTERNS_GENERIC_LOOKUP = {
		["All Stats"] 			= {"INT", "SPI"},
		["Intellect"]			= "INT",
		["Spirit"] 				= "SPI",
	
		["Healing Spells"] 		= "HEAL",
		["Increases Healing"] 	= "HEAL",
		["Healing and Spell Damage"] = "HEAL",
		["Damage and Healing Spells"] = "HEAL",
		["Spell Damage and Healing"] = "HEAL",	
		["mana every 5 sec"] 	= "MANAREG",
		["Mana Regen"] 			= "MANAREG",
		["Mana"]				= "MANA",
	};	
	
	-- next we try to match against one pattern of stage 1 and one pattern of stage 2 and concatenate the effect strings
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE1 = {
	}; 	
	
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE2 = {
	}; 	
	
	-- finally if we got no match, we match against some special enchantment patterns.
	HEALPOINTSBS_PATTERNS_OTHER = {
		{ pattern = "Mana Regen (%d+) per 5 sec%.", effect = "MANAREG" },
		{ pattern = "Zandalar Signet of Mojo", effect = "HEAL", value = 18 },
		{ pattern = "Zandalar Signet of Serenity", effect = "HEAL", value = 33 },
		
		{ pattern = "Minor Wizard Oil", effect = "HEAL", value = 8 },
		{ pattern = "Lesser Wizard Oil", effect = "HEAL", value = 16 },
		{ pattern = "Wizard Oil", effect = "HEAL", value = 24 },
		{ pattern = "Brilliant Wizard Oil", effect = {"HEAL", "SPELLCRIT"}, value = {36, 1} },
	
		{ pattern = "Minor Mana Oil", effect = "MANAREG", value = 4 },
		{ pattern = "Lesser Mana Oil", effect = "MANAREG", value = 8 },
		{ pattern = "Brilliant Mana Oil", effect = { "MANAREG", "HEAL"}, value = {12, 25} },	
	};

elseif (GetLocale() == "deDE") then
	-- Prfixe fr passive und Set-Boni
	HEALPOINTSBS_PREFIX_EQUIP = "Anlegen: ";
	HEALPOINTSBS_PREFIX_SET = "Set: ";
	
	-- Suchmuster fr passive Boni. Wird auf Zeilen angewandt, die mit obigen Prfixen beginnen.
	HEALPOINTSBS_PATTERNS_PASSIVE = {
		{ pattern = "Erh\195\182ht Eure Chance, einen kritischen Schlag durch Zauber zu erzielen, um (%d+)%%%.", effect = "SPELLCRIT" },
		{ pattern = "Erh\195\182ht Eure Chance, einen kritischen Schlag durch Heiligzauber zu erzielen, um (%d+)%%%.", effect = "HOLYCRIT" },
		{ pattern = "Erh\195\182ht durch Zauber und magische Effekte zugef\195\188gten Schaden und Heilung um bis zu (%d+)%.", effect = "HEAL" },
		{ pattern = "Erh\195\182ht durch Zauber und Effekte verursachte Heilung um bis zu (%d+)%.", effect = "HEAL" },
		{ pattern = "Erh\195\182ht die durch Zauber und Effekte verursachte Heilung um bis zu (%d+)%.", effect = "HEAL" },
		{ pattern = "Stellt alle 5 Sek%. (%d+) Punkt%(e%) Mana wieder her%.", effect = "MANAREG" },

		{ pattern = "Erm\195\182glicht, dass (%d+)%% Eurer Manaregeneration w\195\164hrend des Zauberwirkens weiterl\195\164uft%.", effect = "CASTINGREG"},		
		{ pattern = "Erh\195\182ht Eure Chance, einen kritischen Schlag durch Naturzauber zu erzielen, um (%d+)%%%.", effect = "NATURECRIT"}, 
		{ pattern = "Verringert die Zauberzeit Eures %'Nachwachsen%'%-Zaubers um 0%.(%d+) Sekunden%.", effect = "CASTINGREGROWTH"}, 
		{ pattern = "Verringert die Zauberzeit Eures %'Heiliges Licht%'%-Zaubers um 0%.(%d+) Sekunden%.", effect = "CASTINGHOLYLIGHT"}, 
		{ pattern = "%-0%.(%d+) Sek%. Zauberzeit f\195\188r Euren %'Blitzheilungs%'%-Zauber%.", effect = "CASTINGFLASHHEAL"}, 
		{ pattern = "Zauberzeit von Kettenheilung um %-0%.(%d+) Sekunden reduziert%.", effect = "CASTINGCHAINHEAL"},
    { pattern = "Verringert die Zauberzeit Eures Zaubers %'Heilende Ber\195\188hrung%' um 0%.(%d+) Sekunden%.", effect = "CASTINGHEALINGTOUCH"},
		{ pattern = "Verl\195\164ngert die Dauer eures %'Verj\195\188ngung%'%-Zaubers um (%d+) Sekunden%.", effect = "DURATIONREJUV"},
		{ pattern = "Erh\195\182ht die Dauer Eures Erneuern-Zaubers um (%d+) Sekunden%.", effect = "DURATIONRENEW"},
		{ pattern = "Erh\195\182ht Gesundheit%- und Manaregeneration um (%d+)%.", effect = "MANAREGNORMAL"},
		{ pattern = "Erh\195\182ht den geheilten Wert bei jedem Ziel nach dem ersten um (%d+)%%%.", effect = "IMPCHAINHEAL"},
    { pattern = "Erh\195\182ht die Heilwirkung Eures Zaubers %'Verj\195\188ngung%' um bis zu (%d+)%.", effect = "IMPREJUVENATION"},
    { pattern = "Erh\195\182ht die Heilung Eures Zaubers %'Geringe Welle der Heilung%' um bis zu (%d+)%.", effect = "IMPLESSERHEALINGWAVE"}
  };
		
		
	-- Suchmuster fr allgemeine Gegenstandsboni in der Form "+xx bonus" oder "bonus +xx" (%-Zeichen nach dem Wert ist optional)
	
	-- Zuerst wird versucht den "bonus"-String in der folgenden Tabelle nachzuschlagen
	HEALPOINTSBS_PATTERNS_GENERIC_LOOKUP = {
		["Alle Werte"] 			= {"INT", "SPI"},
		["Intelligenz"]			= "INT",
		["Willenskraft"] 		= "SPI",
	
		["Mana alle 5 Sek"] 	= "MANAREG",
		["Manaregeneration"]	= "MANAREG",
		["Heilzauber"]			= "HEAL",
		["Heilung und Zauberschaden"] = "HEAL",
		["Mana"]				= "MANA",
	};
	
	-- ... dann wird versucht ob eines der Stage 1 und eines der Stage 2 Muster passt und daraus ein Effect-String zusammengesetzt
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE1 = {
	}; 	
	
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE2 = {
	}; 	
	
	-- Zuletzt, falls immer noch kein Treffer vorliegt wird noch auf einige spezielle Verzauberungen berprft.
	HEALPOINTSBS_PATTERNS_OTHER = {
		{ pattern = "Manaregeneration (%d+) per 5 Sek%.", effect = "MANAREG" },
		{ pattern = "Zandalarianisches Siegel des Mojo", effect = "HEAL", value = 18 },
		{ pattern = "Zandalarianisches Siegel der Inneren Ruhe", effect = "HEAL", value = 33 },
		
		{ pattern = "Schwaches Zauber\195\182l", effect = "HEAL", value = 8 },
		{ pattern = "Geringes Zauber\195\182l", effect = "HEAL", value = 16 },
		{ pattern = "Zauber\195\182l", effect = "HEAL", value = 24 },
		{ pattern = "Hervorragendes Zauber\195\182l", effect = {"HEAL", "SPELLCRIT"}, value = {36, 1} },
	
		{ pattern = "Schwaches Mana\195\182l", effect = "MANAREG", value = 4 },
		{ pattern = "Geringes Mana\195\182l", effect = "MANAREG", value = 8 },
		{ pattern = "Hervorragendes Mana\195\182l", effect = { "MANAREG", "HEAL"}, value = {12, 25} }
	
	};
elseif (GetLocale() == "frFR") then
	HEALPOINTSBS_PREFIX_EQUIP = "Equip\195\169 : ";
	HEALPOINTSBS_PREFIX_SET = "Ensemble : ";
	
	HEALPOINTSBS_PATTERNS_PASSIVE = {
		{ pattern = "Augmente vos chances d%'infliger des coups critiques avec vos sorts de (%d+)%%%.", effect = "SPELLCRIT" },
		{ pattern = "Augmente vos chances d%'infliger un coup critique avec vos sorts du Sacr\195\169 de (%d+)%%%.", effect = "HOLYCRIT" },
		{ pattern = "Augmente les effets des sorts de soins de (%d+)% au maximum%.", effect = "HEAL" },
		{ pattern = "Augmente les soins prodigu\195\169s par les sorts et effets de (%d+)% au maximum%.", effect = "HEAL" },
		{ pattern = "Augmente les d\195\169g\195\162ts et les soins produits par les sorts et effets magiques de (%d+)% au maximum%.", effect = "HEAL" },
		{ pattern = "Rend (%d+) points de mana toutes les 5 secondes%.", effect = "MANAREG" },

		-- Added
		{ pattern = "(%d+)%% de votre vitesse de r\195\169cup\195\169ration du Mana sont actifs lorsque vous incantez%.", effect = "CASTINGREG"},		
		{ pattern = "Vous conf\195\168re (%d+)%% de votre vitesse normale de r\195\169cup\195\169ration du mana pendant l%'incantation%.", effect = "CASTINGREG"},
		{ pattern = "Augmente vos chances d%'infliger un coup critique avec les sorts de Nature de (%d+)%%%.", effect = "NATURECRIT"}, 
		{ pattern = "R\195\169duit le temps d%'incantation de votre sort R\195\169tablissement de 0%.(%d+) sec%.", effect = "CASTINGREGROWTH"}, 
		{ pattern = "R\195\169duit le temps d%'incantation de votre sort Lumi\195\168re sacr\195\169e de 0%.(%d+) sec%.", effect = "CASTINGHOLYLIGHT"}, 
		{ pattern = "%-0%.(%d+) sec%. au temps d%'incantation de votre sort Soins rapides%.", effect = "CASTINGFLASHHEAL"}, 
		{ pattern = "%-0%,(%d+) secondes au temps d%'incantation de votre sort Salve de gu\195\169rnison%.", effect = "CASTINGCHAINHEAL"},
    { pattern = "R\195\169duit le temps de lancement de Toucher Gu\195\169risseur de 0%.(%d+) secondes%.", effect = "CASTINGHEALINGTOUCH"},
		{ pattern = "Augmente la dur\195\169e de votre sort R\195\169cup\195\169ration de (%d+) sec%.", effect = "DURATIONREJUV"},
		{ pattern = "Augmente la dur\195\169e de votre sort R\195\169novation de (%d+) sec%.", effect = "DURATIONRENEW"},
		{ pattern = "Augmente la r\195\169g\195\169n\195\169ration des points de vie et de mana de (%d+)%.", effect = "MANAREGNORMAL"},
		{ pattern = "Augmente de (%d+)%% le montant de points de vie rendus par Salve de gu\195\169rison aux cibles qui suivent la premi\195\168re%.", effect = "IMPCHAINHEAL"},
    { pattern = "Augmente les soins prodigu\195\169s par R\195\169cup\195\169ration de (%d+) au maximum%.", effect = "IMPREJUVENATION"},
    { pattern = "Augmente les soins prodigu\195\169s par votre Vague de Soins Inf\195\169rieurs de (%d+)%.", effect = "IMPLESSERHEALINGWAVE"}
	};
	
	HEALPOINTSBS_PATTERNS_GENERIC_LOOKUP = {
		["Toutes les caract\195\169ristiques"] = {"INT", "SPI"},
		["Intelligence"] = "INT",
		["Esprit"] = "SPI",
		["Sorts de Soins"] = "HEAL",
		["Mana chaque 5 sec."] = "MANAREG",
		["D\195\169g\195\162ts et soins "] = "HEAL",
		["Mana"] = "MANA",
	};
		
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE1 = {
	};
	
	HEALPOINTSBS_PATTERNS_GENERIC_STAGE2 = {
	};
	
	HEALPOINTSBS_PATTERNS_OTHER = {
		{ pattern = "Mana chaque (%d+) per 5 sec%.", effect = "MANAREG" }, --?
		{ pattern = "Cachet de mojo zandalar", effect = "HEAL", value = 18 }, --?
		{ pattern = "Cachet de s\195\169r\195\169nit\195\169 zandalar", effect = "HEAL", value = 33 }, 
		
		{ pattern = "Huile de sorcier mineure", effect = "HEAL", value = 8 },
		{ pattern = "Huile de sorcier inf\195\169rieure", effect = "HEAL", value = 16 },
		{ pattern = "Huile de sorcier", effect = "HEAL", value = 24 },
		{ pattern = "Huile de sorcier brillante", effect = {"HEAL", "SPELLCRIT"}, value = {36, 1} },
	
		{ pattern = "Huile de mana mineure", effect = "MANAREG", value = 4 },
		{ pattern = "Huile de mana inf\195\169rieure", effect = "MANAREG", value = 8 },
		{ pattern = "Huile de mana brillante", effect = { "MANAREG", "HEAL"}, value = {12, 25} },	
	};
end