

-- Global variables
local SPELLTABLE = { };
local SELECTED = { };
local HPC_ManaRegainedOnCrit = 0;
local HPC_ExtraRegrowthCrit = 0;
local HPC_ExtraMana = 0;	
local HPC_ExtraInt = 0; 
local HPC_ExtraSpi = 0;
local HP_LastPowerfulCurrent = nil;
local HP_LastPowerfulNew = nil;
local HP_LastEfficientCurrent = nil;
local HP_LastEfficientNew = nil;
local TH_TotalTimeCurrent = { };
local TH_TotalTimeNew = { };

-- Spell tables
local Paladin_Fast = {	{ name = HPC_SPELL_FOL, type = 'normal', rank = 1, abbr = "FoL", avg = 67, time = 1.5, mana = 35, level = 20, bolfactor = 1}, 
						{ name = HPC_SPELL_FOL, type = 'normal', rank = 2, abbr = "FoL", avg = 103, time = 1.5, mana = 50, level = 26, bolfactor = 1},
						{ name = HPC_SPELL_FOL, type = 'normal', rank = 3, abbr = "FoL", avg = 154, time = 1.5, mana = 70, level = 34, bolfactor = 1},
						{ name = HPC_SPELL_FOL, type = 'normal', rank = 4, abbr = "FoL", avg = 209, time = 1.5, mana = 90, level = 42, bolfactor = 1},
						{ name = HPC_SPELL_FOL, type = 'normal', rank = 5, abbr = "FoL", avg = 283, time = 1.5, mana = 115, level = 50, bolfactor = 1},
						{ name = HPC_SPELL_FOL, type = 'normal', rank = 6, abbr = "FoL", avg = 363, time = 1.5, mana = 140, level = 58, bolfactor = 1}};
local Paladin_Slow = {	{ name = HPC_SPELL_HL, type = 'normal', rank = 1, abbr = "HL", avg = 43, time = 2.5, mana = 35, level = 1, bolfactor = 0.2},	
						{ name = HPC_SPELL_HL, type = 'normal', rank = 2, abbr = "HL", avg = 83, time = 2.5, mana = 60, level = 6, bolfactor = 0.4},
						{ name = HPC_SPELL_HL, type = 'normal', rank = 3, abbr = "HL", avg = 173, time = 2.5, mana = 110, level = 14, bolfactor = 0.7},
						{ name = HPC_SPELL_HL, type = 'normal', rank = 4, abbr = "HL", avg = 333, time = 2.5, mana = 190, level = 22, bolfactor = 1},				
						{ name = HPC_SPELL_HL, type = 'normal', rank = 5, abbr = "HL", avg = 522, time = 2.5, mana = 275, level = 30, bolfactor = 1},				
						{ name = HPC_SPELL_HL, type = 'normal', rank = 6, abbr = "HL", avg = 739, time = 2.5, mana = 365, level = 38, bolfactor = 1},				
						{ name = HPC_SPELL_HL, type = 'normal', rank = 7, abbr = "HL", avg = 999, time = 2.5, mana = 465, level = 46, bolfactor = 1},				
						{ name = HPC_SPELL_HL, type = 'normal', rank = 8, abbr = "HL", avg = 1317, time = 2.5, mana = 580, level = 54, bolfactor = 1},
						{ name = HPC_SPELL_HL, type = 'normal', rank = 9, abbr = "HL", avg = 1680, time = 2.5, mana = 660, level = 60, bolfactor = 1}};
local Paladin_Instant = { { name = HPC_SPELL_HS, type = 'instant', rank = 1, abbr = "HS", avg = 212, time = 30, mana = 220, level = 40},
            { name = HPC_SPELL_HS, type = 'instant', rank = 2, abbr = "HS", avg = 290, time = 30, mana = 275, level = 48},
            { name = HPC_SPELL_HS, type = 'instant', rank = 3, abbr = "HS", avg = 370, time = 30, mana = 325, level = 56}};
local Paladin_BoL =  {	{ HL = 210, FoL = 60},
						{ HL = 300, FoL = 85},
						{ HL = 400, FoL = 115}};

local Priest_Fast = {	{ name = HPC_SPELL_FH, type = 'normal', rank = 1, abbr = "FH", avg = 215, time = 1.5, mana = 125, level = 20}, 
						{ name = HPC_SPELL_FH, type = 'normal', rank = 2, abbr = "FH", avg = 286, time = 1.5, mana = 155, level = 26},
						{ name = HPC_SPELL_FH, type = 'normal', rank = 3, abbr = "FH", avg = 360, time = 1.5, mana = 185, level = 32},
						{ name = HPC_SPELL_FH, type = 'normal', rank = 4, abbr = "FH", avg = 439, time = 1.5, mana = 215, level = 38},
						{ name = HPC_SPELL_FH, type = 'normal', rank = 5, abbr = "FH", avg = 567, time = 1.5, mana = 265, level = 44},
						{ name = HPC_SPELL_FH, type = 'normal', rank = 6, abbr = "FH", avg = 704, time = 1.5, mana = 315, level = 50},
						{ name = HPC_SPELL_FH, type = 'normal', rank = 7, abbr = "FH", avg = 885, time = 1.5, mana = 380, level = 56}};
local Priest_Slow = {	{ name = HPC_SPELL_LH, type = 'normal', rank = 1, abbr = "LH", avg = 53, time = 1.5, mana = 30, level = 1}, 
						{ name = HPC_SPELL_LH, type = 'normal', rank = 2, abbr = "LH", avg = 84, time = 2.0, mana = 45, level = 4},
						{ name = HPC_SPELL_LH, type = 'normal', rank = 3, abbr = "LH", avg = 154, time = 2.5, mana = 75, level = 10},
						{ name = HPC_SPELL_HEAL, type = 'normal', rank = 1, abbr = "Heal", avg = 330, time = 3.0, mana = 155, level = 16},
						{ name = HPC_SPELL_HEAL, type = 'normal', rank = 2, abbr = "Heal", avg = 476, time = 3.0, mana = 205, level = 22},
						{ name = HPC_SPELL_HEAL, type = 'normal', rank = 3, abbr = "Heal", avg = 624, time = 3.0, mana = 255, level = 28},
						{ name = HPC_SPELL_HEAL, type = 'normal', rank = 4, abbr = "Heal", avg = 781, time = 3.0, mana = 305, level = 34},
						{ name = HPC_SPELL_GH, type = 'normal', rank = 1, abbr = "GH", avg = 967, time = 3.0, mana = 370, level = 40},
						{ name = HPC_SPELL_GH, type = 'normal', rank = 2, abbr = "GH", avg = 1248, time = 3.0, mana = 455, level = 46}, 
						{ name = HPC_SPELL_GH, type = 'normal', rank = 3, abbr = "GH", avg = 1556, time = 3.0, mana = 545, level = 52},
						{ name = HPC_SPELL_GH, type = 'normal', rank = 4, abbr = "GH", avg = 1917, time = 3.0, mana = 655, level = 58},
						{ name = HPC_SPELL_GH, type = 'normal', rank = 5, abbr = "GH", avg = 2080, time = 3.0, mana = 710, level = 60}};
local Priest_Hot = {	{ name = HPC_SPELL_RENEW, type = 'hot', rank = 1, abbr = "Renew", avg = 45, time = 15, mana = 30, level = 8}, 
						{ name = HPC_SPELL_RENEW, type = 'hot', rank = 2, abbr = "Renew", avg = 100, time = 15, mana = 65, level = 14},
						{ name = HPC_SPELL_RENEW, type = 'hot', rank = 3, abbr = "Renew", avg = 175, time = 15, mana = 105, level = 20},
						{ name = HPC_SPELL_RENEW, type = 'hot', rank = 4, abbr = "Renew", avg = 245, time = 15, mana = 140, level = 26},
						{ name = HPC_SPELL_RENEW, type = 'hot', rank = 5, abbr = "Renew", avg = 315, time = 15, mana = 170, level = 32},
						{ name = HPC_SPELL_RENEW, type = 'hot', rank = 6, abbr = "Renew", avg = 400, time = 15, mana = 205, level = 38},
						{ name = HPC_SPELL_RENEW, type = 'hot', rank = 7, abbr = "Renew", avg = 510, time = 15, mana = 250, level = 44},
						{ name = HPC_SPELL_RENEW, type = 'hot', rank = 8, abbr = "Renew", avg = 650, time = 15, mana = 305, level = 50},
						{ name = HPC_SPELL_RENEW, type = 'hot', rank = 9, abbr = "Renew", avg = 810, time = 15, mana = 365, level = 56},
						{ name = HPC_SPELL_RENEW, type = 'hot', rank = 10, abbr = "Renew", avg = 970, time = 15, mana = 410, level = 60}};
				
local Druid_Fast = {	{ name = HPC_SPELL_REGR, type = 'regrowth', rank = 1, abbr = "Regr", avg = 100, time = 2, mana = 120, hotavg = 98, hottime = 21, level = 12}, 
						{ name = HPC_SPELL_REGR, type = 'regrowth', rank = 2, abbr = "Regr", avg = 176, time = 2, mana = 205, hotavg = 175, hottime = 21, level = 18},
						{ name = HPC_SPELL_REGR, type = 'regrowth', rank = 3, abbr = "Regr", avg = 257, time = 2, mana = 280, hotavg = 259, hottime = 21, level = 24},
						{ name = HPC_SPELL_REGR, type = 'regrowth', rank = 4, abbr = "Regr", avg = 339, time = 2, mana = 350, hotavg = 343, hottime = 21, level = 30},
						{ name = HPC_SPELL_REGR, type = 'regrowth', rank = 5, abbr = "Regr", avg = 431, time = 2, mana = 420, hotavg = 427, hottime = 21, level = 36},
						{ name = HPC_SPELL_REGR, type = 'regrowth', rank = 6, abbr = "Regr", avg = 543, time = 2, mana = 510, hotavg = 546, hottime = 21, level = 42},
						{ name = HPC_SPELL_REGR, type = 'regrowth', rank = 7, abbr = "Regr", avg = 685, time = 2, mana = 615, hotavg = 686, hottime = 21, level = 48},
						{ name = HPC_SPELL_REGR, type = 'regrowth', rank = 8, abbr = "Regr", avg = 857, time = 2, mana = 740, hotavg = 861, hottime = 21, level = 54},
						{ name = HPC_SPELL_REGR, type = 'regrowth', rank = 9, abbr = "Regr", avg = 1061, time = 2, mana = 880, hotavg = 1064, hottime = 21, level = 60}};
local Druid_Slow = { 	{ name = HPC_SPELL_HT, type = 'normal', rank = 1, abbr = "HT", avg = 44, time = 1.5, mana = 25, level = 1}, 
						{ name = HPC_SPELL_HT, type = 'normal', rank = 2, abbr = "HT", avg = 100, time = 2.0, mana = 55, level = 8}, 
						{ name = HPC_SPELL_HT, type = 'normal', rank = 3, abbr = "HT", avg = 219, time = 2.5, mana = 110, level = 14}, 
						{ name = HPC_SPELL_HT, type = 'normal', rank = 4, abbr = "HT", avg = 404, time = 3.0, mana = 185, level = 20}, 
						{ name = HPC_SPELL_HT, type = 'normal', rank = 5, abbr = "HT", avg = 633, time = 3.5, mana = 270, level = 26},
						{ name = HPC_SPELL_HT, type = 'normal', rank = 6, abbr = "HT", avg = 818, time = 3.5, mana = 335, level = 32},
						{ name = HPC_SPELL_HT, type = 'normal', rank = 7, abbr = "HT", avg = 1028, time = 3.5, mana = 405, level = 38},
						{ name = HPC_SPELL_HT, type = 'normal', rank = 8, abbr = "HT", avg = 1313, time = 3.5, mana = 495, level = 44},
						{ name = HPC_SPELL_HT, type = 'normal', rank = 9, abbr = "HT", avg = 1656, time = 3.5, mana = 600, level = 50},
						{ name = HPC_SPELL_HT, type = 'normal', rank = 10, abbr = "HT", avg = 2060, time = 3.5, mana = 720, level = 56},
						{ name = HPC_SPELL_HT, type = 'normal', rank = 11, abbr = "HT", avg = 2472, time = 3.5, mana = 800, level = 60}};
local Druid_Hot = {		{ name = HPC_SPELL_REJUV, type = 'hot', rank = 1, abbr = "Rejuv", avg = 32, time = 12, mana = 25, level = 4}, 
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 2, abbr = "Rejuv", avg = 56, time = 12, mana = 40, level = 10},
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 3, abbr = "Rejuv", avg = 116, time = 12, mana = 75, level = 16}, 
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 4, abbr = "Rejuv", avg = 180, time = 12, mana = 105, level = 22},
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 5, abbr = "Rejuv", avg = 244, time = 12, mana = 135, level = 28},
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 6, abbr = "Rejuv", avg = 304, time = 12, mana = 160, level = 34},
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 7, abbr = "Rejuv", avg = 388, time = 12, mana = 195, level = 40},
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 8, abbr = "Rejuv", avg = 488, time = 12, mana = 235, level = 46},
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 9, abbr = "Rejuv", avg = 608, time = 12, mana = 280, level = 52},
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 10, abbr = "Rejuv", avg = 756, time = 12, mana = 335, level = 58},
						{ name = HPC_SPELL_REJUV, type = 'hot', rank = 11, abbr = "Rejuv", avg = 888, time = 12, mana = 360, level = 60}};				

local Shaman_Fast = {	{ name = HPC_SPELL_LHW, type = 'normal', rank = 1, abbr = "LHW", avg = 174, time = 1.5, mana = 105, level = 20},
						{ name = HPC_SPELL_LHW, type = 'normal', rank = 2, abbr = "LHW", avg = 264, time = 1.5, mana = 145, level = 28},
						{ name = HPC_SPELL_LHW, type = 'normal', rank = 3, abbr = "LHW", avg = 359, time = 1.5, mana = 185, level = 36},
						{ name = HPC_SPELL_LHW, type = 'normal', rank = 4, abbr = "LHW", avg = 486, time = 1.5, mana = 235, level = 44},
						{ name = HPC_SPELL_LHW, type = 'normal', rank = 5, abbr = "LHW", avg = 668, time = 1.5, mana = 305, level = 52},
						{ name = HPC_SPELL_LHW, type = 'normal', rank = 6, abbr = "LHW", avg = 880, time = 1.5, mana = 380, level = 60}};
local Shaman_Slow = {	{ name = HPC_SPELL_HW, type = 'normal', rank = 1, abbr = "HW", avg = 39, time = 1.5, mana = 25, level = 1}, 
						{ name = HPC_SPELL_HW, type = 'normal', rank = 2, abbr = "HW", avg = 71, time = 2.0, mana = 45, level = 6},
						{ name = HPC_SPELL_HW, type = 'normal', rank = 3, abbr = "HW", avg = 142, time = 2.5, mana = 80, level = 12},
						{ name = HPC_SPELL_HW, type = 'normal', rank = 4, abbr = "HW", avg = 292, time = 3.0, mana = 155, level = 18},
						{ name = HPC_SPELL_HW, type = 'normal', rank = 5, abbr = "HW", avg = 408, time = 3.0, mana = 200, level = 24},
						{ name = HPC_SPELL_HW, type = 'normal', rank = 6, abbr = "HW", avg = 579, time = 3.0, mana = 265, level = 32},
						{ name = HPC_SPELL_HW, type = 'normal', rank = 7, abbr = "HW", avg = 797, time = 3.0, mana = 340, level = 40},
						{ name = HPC_SPELL_HW, type = 'normal', rank = 8, abbr = "HW", avg = 1092, time = 3.0, mana = 440, level = 48},
						{ name = HPC_SPELL_HW, type = 'normal', rank = 9, abbr = "HW", avg = 1464, time = 3.0, mana = 560, level = 56},
						{ name = HPC_SPELL_HW, type = 'normal', rank = 10, abbr = "HW", avg = 1735, time = 3.0, mana = 620, level = 60}};
local Shaman_Chain = {  { name = HPC_SPELL_CHAIN, type = 'chain', rank = 1, abbr = "CH", avg = 344, time = 2.5, mana = 260, level = 40},
						{ name = HPC_SPELL_CHAIN, type = 'chain', rank = 2, abbr = "CH", avg = 435, time = 2.5, mana = 315, level = 46},
						{ name = HPC_SPELL_CHAIN, type = 'chain', rank = 3, abbr = "CH", avg = 590, time = 2.5, mana = 405, level = 54}};

-- Helper functions
local function setStat(statString, stat, delta)
	if (delta == 0) then
		statString:SetText(stat);
	elseif (delta > 0) then
		statString:SetText(GREEN_FONT_COLOR_CODE..stat..FONT_COLOR_CODE_CLOSE);
	else 
		statString:SetText(RED_FONT_COLOR_CODE..stat..FONT_COLOR_CODE_CLOSE);
	end	
end

local function isPlayerBuffUp(buffName)
  local iIterator = 1
  while (UnitBuff("player", iIterator)) do
    if (string.find(UnitBuff("player", iIterator), buffName)) then
      return true
    end
    iIterator = iIterator + 1
  end
  return false
end;

local function getHighestSpellRank(spellName)
	local totalSpellTabs = GetNumSpellTabs();
	local totalSpells = 0;
	for t = 1, totalSpellTabs do
		local _, _, _, numSpells = GetSpellTabInfo(t);
		totalSpells = totalSpells + numSpells;
	end

	local highestRank = 0;
	for t = 1, totalSpells do
		local nameSpell, rankSpell = GetSpellName(t, BOOKTYPE_SPELL);	
		if (nameSpell == spellName) then		
			local j, k = string.find(rankSpell, HPC_DIV_RANK.." ");	
			if (j ~= nil) then
				highestRank = math.max(highestRank, string.sub(rankSpell, k));
			end
		end
	end
	return highestRank;
end

local function getTalentRank(talentName)
	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
		local numTalents = GetNumTalents(t);
		for i=1, numTalents do
			local nameTalent, _, _, _, currRank, _ = GetTalentInfo(t,i); 
			if (nameTalent == talentName) then
				return currRank
			end
		end
	end
	return 0;
end

local function getHPCast(spell, healing, spellCrit)
	local healFactor = 1;
	if (spell['level'] < 20) then
		healFactor = 1 - ((20 - spell['level']) * 0.0375);
	end
	
	local out = spell['avg'];
	if (spell['type'] == 'regrowth') then
		-- Static part
		out = out + ((healFactor * healing / 2) / (3.5 / (math.min(spell['orgtime'], 3.5))));
		out = out + ((spellCrit + HPC_ExtraRegrowthCrit) / 200) * out;		-- Crit adds 50% for non-hot
		-- HOT part
		out = out + spell['hotavg'];
		out = out + ((healFactor * healing / 2) / (15 / (math.min(spell['hottime'], 15))));
	elseif (spell['type'] == 'chain') then
		out = out + (healFactor * healing / (3.5 / (math.min(spell['orgtime'], 3.5))));
		local impChainHeal = HealPointsBS:GetBonus('IMPCHAINHEAL');
		out = out * (1 + 0.5 * (1 + impChainHeal / 100) + 0.25 * (1 + impChainHeal / 100)); -- Assumes that the spell hits all 3 targets
		out = out + (spellCrit / 200) * out;												-- Crit adds 50% for non-hot
	elseif (spell['type'] == 'hot') then
    if (spell['name'] == HPC_SPELL_REJUV and HealPointsBS:GetBonus('IMPREJUVENATION') > 0) then
      healing = healing + HealPointsBS:GetBonus('IMPREJUVENATION');
    end
    out = out + (healFactor * healing / (15 / (math.min(spell['orgtime'], 15))));
  elseif (spell['type'] == 'instant') then
    out = out + (healFactor * healing / 1.5);
  else
		if (getglobal("HealPointsCalculatorBoL"):GetChecked() == 1) then
			local bolRank = getHighestSpellRank(HPC_SPELL_BOL);
			if (bolRank > 0) then
				local bol = Paladin_BoL[bolRank];
				out = out + spell['bolfactor'] * bol[spell['abbr']];
			end
		end
    if (spell['name'] == HPC_SPELL_LHW and HealPointsBS:GetBonus('IMPLESSERHEALINGWAVE') > 0) then
      healing = healing + HealPointsBS:GetBonus('IMPLESSERHEALINGWAVE');
    end
    out = out + (healFactor * healing / (3.5 / (math.min(spell['orgtime'], 3.5))));
		out = out + (spellCrit / 200) * out;		-- Crit adds 50% for non-hot
	end
	return out;
end

local function getHPSec(spell, healing, spellCrit)
	local out = getHPCast(spell, healing, spellCrit);

	if (spell['type'] == 'regrowth') then
		return out/(spell['hottime'] + spell['time']);	
	else
		return out/spell['time'];
	end
end

local function getHPMana(spell, healing, spellCrit)
	local out = getHPCast(spell, healing, spellCrit);

	return out / (spell['mana'] * (1 - (spellCrit / 100) * HPC_ManaRegainedOnCrit));
end

local function getHPTotal(hpMana, mana)
	return hpMana * mana;
end

local function getHPTotalRegen(spell, healing, spellCrit, manaRegenCasting, mana)
	local manaCostSpell = spell['mana'] * (1 - (spellCrit / 100) * HPC_ManaRegainedOnCrit);
	local manaRegen = spell['time'] * (manaRegenCasting / 5);
	if (spell['type'] == 'regrowth') then
		manaRegen = (spell['time'] + spell['hottime']) * (manaRegenCasting / 5);
	end
	local manaUsageSpell = manaCostSpell - manaRegen;
	
	local hpPerCast = getHPCast(spell, healing, spellCrit);
	local hpPerMana = hpPerCast / manaUsageSpell;
	local hpPerManaBar = hpPerMana * mana;
	
	local numberCasts = mana / manaUsageSpell;
	local totalTime = numberCasts * spell['time'];
	if (spell['type'] == 'regrowth') then
		totalTime = numberCasts * (spell['time'] + spell['hottime']);
	end
	
	return hpPerManaBar, totalTime;
end

local function updateSpellTalents(slow, fast, hot)	
	local function clone(t)            -- return a copy of the table t
		if (t == nil) then
			return nil
		end
		local new = {}             -- create a new table
		local i, v = next(t, nil)  -- i is an index of t, v = t[i]
		while i do
			new[i] = v
			i, v = next(t, i)        -- get next index
		end
		new['orgtime'] = t['time']; -- copy the time-stat
		return new
	end

	local function updateSpellPercent(spell, aspect, percentIncrease)
		if (spell ~= nil) then
			spell[aspect] = spell[aspect] * (1 + percentIncrease);
		end
	end
	
	local function updateSpellAbsolute(spell, aspect, increase)
		if (spell ~= nil) then
			spell[aspect] = spell[aspect] + increase;
		end
	end
	
	slow = clone(slow);
	fast = clone(fast);
	hot = clone(hot);
	HPC_ManaRegainedOnCrit = 0;
	HPC_ExtraRegrowthCrit = 0;
	HPC_ExtraMana = 0;
	HPC_ExtraInt = 0;
	local _, className = UnitClass("player");
	
	if (className == "PALADIN") then
		-- talents for paladins
		local divineIntellect = getTalentRank(HPC_TALENT_DIVINT);	-- Increases intellect by 2% per rank
		HPC_ExtraInt = 0.02 * divineIntellect;
		
		local healingLight = getTalentRank(HPC_TALENT_HEALIG);		-- Increases avg for both spells by 4% per rank
		updateSpellPercent(slow, 'avg', healingLight * 0.04);
		updateSpellPercent(fast, 'avg', healingLight * 0.04);
		
		local illumination = getTalentRank(HPC_TALENT_ILLUMI);			-- 20% chance to regain mana on crit per rank
		HPC_ManaRegainedOnCrit = 0.20 * illumination;
		
		-- special set bonuses
		if (HealPointsBS:GetBonus('CASTINGHOLYLIGHT') > 0) then
			updateSpellAbsolute(slow, 'time', - HealPointsBS:GetBonus('CASTINGHOLYLIGHT') / 10);
		end

	elseif (className == "PRIEST") then
		-- talents for priests
		local mentalAgility = getTalentRank(HPC_TALENT_MENAGI);		-- Reduced mana cost for Renew by 2% per rank
		updateSpellPercent(hot, 'mana', - mentalAgility * 0.02);
		
		local improvedRenew = getTalentRank(HPC_TALENT_IMPREN);		-- Increased avg for Renew by 5% per rank
		updateSpellPercent(hot, 'avg', improvedRenew * 0.05);
		
		local spiritualHealing = getTalentRank(HPC_TALENT_SPIHEA);-- Increased avg for all spells by 2% per rank
		updateSpellPercent(fast, 'avg', spiritualHealing * 0.02);
		updateSpellPercent(slow, 'avg', spiritualHealing * 0.02);
		updateSpellPercent(hot, 'avg', spiritualHealing * 0.02);
		
		local improvedHealing = getTalentRank(HPC_TALENT_IMPHEA);  -- Reduced mana cost for slow heal by 5% per rank
		updateSpellPercent(slow, 'mana', - improvedHealing * 0.05);
		
		if (slow ~= nil and slow['name'] ~= HPC_SPELL_LH) then
			local divineFury = getTalentRank(HPC_TALENT_DIVFUR);	   -- Reduced time for Heal/Greater Heal by 0.1 per rank
			updateSpellAbsolute(slow, 'time', - divineFury * 0.1);
		end
		
		local mentalStrength = getTalentRank(HPC_TALENT_MENSTR);	-- Increases maximum mana by 2% per rank
		HPC_ExtraMana = 0.02 * mentalStrength;

		-- special set bonuses
		if (HealPointsBS:GetBonus('CASTINGFLASHHEAL') > 0) then
			updateSpellAbsolute(fast, 'time', - HealPointsBS:GetBonus('CASTINGFLASHHEAL') / 10);
		end

		if (HealPointsBS:GetBonus('DURATIONRENEW') > 0) then
			updateSpellAbsolute(hot, 'time', HealPointsBS:GetBonus('DURATIONRENEW'));
			updateSpellPercent(hot, 'avg', HealPointsBS:GetBonus('DURATIONRENEW') / 15); -- From 5 tics to 6 tics => 20 % increase
		end
		
	elseif (className == "DRUID") then
		-- talents for druids
		local moonglow = getTalentRank(HPC_TALENT_MOONGL);					-- Reduced mana cost for all spells by 3% per rank
		updateSpellPercent(fast, 'mana', - moonglow * 0.03);
		updateSpellPercent(slow, 'mana', - moonglow * 0.03);
		updateSpellPercent(hot, 'mana', - moonglow * 0.03);
		
		local improvedHT = getTalentRank(HPC_TALENT_IMPRHT)	-- Reduced time for Healing Touch by 0.1 per rank
		updateSpellAbsolute(slow, 'time', - improvedHT * 0.1);
		
		local tranquilSpirit = getTalentRank(HPC_TALENT_TRASPI)		-- Reduced mana cost for Healing Touch by 2% per rank
		updateSpellPercent(slow, 'mana', - tranquilSpirit * 0.02);
		
		local improvedRejuv = getTalentRank(HPC_TALENT_IMPREJ)-- Increased avg for Rejuvenation by 5% per rank
		updateSpellPercent(hot, 'avg', improvedRejuv * 0.05);
		
		local giftOfNature = getTalentRank(HPC_TALENT_GIOFNA)		-- Increased avg for all spells by 2% per rank
		updateSpellPercent(fast, 'avg', giftOfNature * 0.02);
		updateSpellPercent(fast, 'hotavg', giftOfNature * 0.02);
		updateSpellPercent(slow, 'avg', giftOfNature * 0.02);
		updateSpellPercent(hot, 'avg', giftOfNature * 0.02);

		local improvedRegrowth = getTalentRank(HPC_TALENT_IMPREG);	-- Increases crit for Regrowth by 10% per rank
		HPC_ExtraRegrowthCrit = 10 * improvedRegrowth;
		
		local heartOfTheWild = getTalentRank(HPC_TALENT_HEOFWI);	-- Increases int by 4% per rank
		HPC_ExtraInt = 0.04 * heartOfTheWild;

		-- special set bonuses
		if (HealPointsBS:GetBonus('CASTINGREGROWTH') > 0) then
			updateSpellAbsolute(fast, 'time', - HealPointsBS:GetBonus('CASTINGREGROWTH') / 10);
		end

    if (HealPointsBS:GetBonus('CASTINGHEALINGTOUCH') > 0) then
      updateSpellAbsolute(slow, 'time', - HealPointsBS:GetBonus('CASTINGHEALINGTOUCH') / 100); -- find a more reliable way
    end

    if (HealPointsBS:GetBonus('DURATIONREJUV') > 0) then
			updateSpellAbsolute(hot, 'time', HealPointsBS:GetBonus('DURATIONREJUV'));
			updateSpellPercent(hot, 'avg', HealPointsBS:GetBonus('DURATIONREJUV') / 12); -- From 4 tics to 5 tics => 25 % increase
		end

	elseif (className == "SHAMAN") then
		-- talents for shaman
		local improvedHealingWave = getTalentRank(HPC_TALENT_IMHEWA)	-- Reduced time for Healing Wave by 0.1 per rank
		updateSpellAbsolute(slow, 'time', - improvedHealingWave * 0.1);
		
		local tidalFocus = getTalentRank(HPC_TALENT_TIDFOC)						-- Reduced mana cost for all spells by 1% per rank
		updateSpellPercent(fast, 'mana', - tidalFocus * 0.01);
		updateSpellPercent(slow, 'mana', - tidalFocus * 0.01);
		updateSpellPercent(hot, 'mana', - tidalFocus * 0.01);
		
		local purification = getTalentRank(HPC_TALENT_PURIFI)					-- Increased avg for all spells by 2% per rank
		updateSpellPercent(fast, 'avg', purification * 0.02);
		updateSpellPercent(slow, 'avg', purification * 0.02);
		updateSpellPercent(hot, 'avg', purification * 0.02);

		local ancestralKnowledge = getTalentRank(HPC_TALENT_ANCKNO);    -- Increases maximum mana by 1% per rank
		HPC_ExtraMana = 0.01 * ancestralKnowledge;
		
		-- special set bonuses
		if (HealPointsBS:GetBonus('CASTINGCHAINHEAL') > 0) then
			updateSpellAbsolute(hot, 'time', - HealPointsBS:GetBonus('CASTINGCHAINHEAL') / 10);
		end
	end
	return slow, fast, hot;
end

local function computeTotalHealing(spell, hps, seconds, startMana, manaRegenCasting, manaRegenNormal, manaRegainFactor)
	--DEFAULT_CHAT_FRAME:AddMessage("Computing total healing for "..spell['name'].."("..spell['rank']..")  secs="..seconds.."  mana="..startMana,1,1,1);

	-- Phase 1: Has mana to chain-cast
	local manaUsageSpell = spell['mana'] * manaRegainFactor;
	local manaUsageSecond = (manaUsageSpell / spell['time']) - (manaRegenCasting / 5);
	local secondsPhase1 = math.min(seconds, startMana / manaUsageSecond);
	local totalHealed = secondsPhase1 * hps;			
	--DEFAULT_CHAT_FRAME:AddMessage("Seconds phase1 "..secondsPhase1,1,1,1);
	--DEFAULT_CHAT_FRAME:AddMessage("Healed phase1 "..totalHealed,1,1,1);

	-- Phase 2: Has no mana left
	local secondsPhase2 = seconds - secondsPhase1;
	if (secondsPhase2 > 0) then
		local cycleTime;                      -- Seconds between each casting
		if (manaRegenCasting > manaUsageSpell) then 	-- chaincast inside 5s rule
			local secs = manaUsageSpell / (manaRegenCasting / 5);
			cycleTime = math.max(secs, spell['time']);
		else
			local manaToRegen = manaUsageSpell - manaRegenCasting;
			cycleTime = 5 + manaToRegen / (manaRegenNormal / 5);
		end
    local hpsPhase2 = hps * spell['time'] / cycleTime;
    local healedPhase2 = hpsPhase2 * secondsPhase2;
	totalHealed = totalHealed + healedPhase2;
  	--DEFAULT_CHAT_FRAME:AddMessage("Cycletime phase2 "..cycleTime,1,1,1);
	--DEFAULT_CHAT_FRAME:AddMessage("Seconds phase2 "..secondsPhase2,1,1,1);
	--DEFAULT_CHAT_FRAME:AddMessage("Healed phase2 "..healedPhase2,1,1,1);		
	end
	return totalHealed;
end

local function computePowerPoints(healing, spellCrit, maxMana, manaRegenCasting, manaRegenNormal, manaRegainFactor) 
	local function getHighestKnownSpell(spellTable)
		if (spellTable == nil) then
			return nil;
		end
		for i = table.getn(spellTable), 1, -1 do
			if (getHighestSpellRank(spellTable[i]['name']) == spellTable[i]['rank']) then
				return spellTable[i];
			end
		end
		return nil;
	end

	-- Healed in 60 sec by most powerful spell
	local testSpells = { };
	testSpells[1] = getHighestKnownSpell(SPELLTABLE[1]);
	testSpells[2] = getHighestKnownSpell(SPELLTABLE[2]);
	testSpells[3] = getHighestKnownSpell(SPELLTABLE[3]);
	
	testSpells[2], testSpells[1], testSpells[3] = updateSpellTalents(testSpells[2], testSpells[1], testSpells[3]);

	local maxHps = 0;
	local powerfulSpell;

	for i = 1, 3 do 
		if (testSpells[i] ~= nil and (testSpells[i]['type'] == 'normal' or testSpells[i]['type'] == 'chain')) then
			local hps = getHPSec(testSpells[i], healing, spellCrit);
			if (hps > maxHps) then
				maxHps = hps;
				powerfulSpell = testSpells[i];
			end
		end
	end
	
	local powerPoints = computeTotalHealing(powerfulSpell, maxHps, 60, maxMana, manaRegenCasting, manaRegenNormal, manaRegainFactor);
	return powerPoints, powerfulSpell;
end

local function computeEndurancePoints(healing, spellCrit, manaRegenCasting, manaRegenNormal, manaRegainFactor) 
	-- Healed in 5 mins by most efficient spell, starting with 0 mana
	local maxNum = math.max(table.getn(SPELLTABLE[2]), table.getn(SPELLTABLE[1]));
	if (SPELLTABLE[3] ~= nil) then 
		maxNum = math.max(maxNum, table.getn(SPELLTABLE[3]));
	end
	
	local efficientSpell = nil;
	local maxEndurancePoints = 0;
	for i = 1, maxNum, 1 do
		local spells = { };
		spells[1] = SPELLTABLE[1][i];
		spells[2] = SPELLTABLE[2][i];
		if (SPELLTABLE[3] ~= nil) then
			spells[3] = SPELLTABLE[3][i];
		end
		
		spells[2], spells[1], spells[3] = updateSpellTalents(spells[2], spells[1], spells[3]);
		
		for j = 1, 3 do 
			if (spells[j] ~= nil and (spells[j]['type'] == 'normal' or spells[j]['type'] == 'chain') and getHighestSpellRank(spells[j]['name']) >= spells[j]['rank']) then
				local hps = getHPSec(spells[j], healing, spellCrit);
				local endurancePoints = computeTotalHealing(spells[j], hps, 5 * 60, 0, manaRegenCasting, manaRegenNormal, manaRegainFactor);
				if (endurancePoints > maxEndurancePoints) then
					efficientSpell = spells[j];
					maxEndurancePoints = endurancePoints;
				end			
			end
		end
	end
	return maxEndurancePoints, efficientSpell;
end

-- Compute old and new values
local function getCurrentAndNewManaRegen()
	local function getRegenSpirit(spirit)																												
		local _, className = UnitClass("player");	
		local regen = 0;
		if (className == "PRIEST") then
			regen = 13 + spirit / 4;
		else
			regen = 15 + spirit / 5; -- paladin, druid, shaman
		end
		return regen * 2.5; -- convert from /2s til /5s
	end

	--[[
	Buffs: 
		Spell_Nature_ManaRegenTotem - Nightfin Soup - 8 mana/5s
	
	]]
	
	local talentMeditation = getTalentRank(HPC_TALENT_MEDITA);	-- 5% spi mana regen while casting per rank (priest)
	local talentReflection = getTalentRank(HPC_TALENT_REFLEC); 	-- 5% spi mana regen while casting per rank (druid)
	local percentRegen = 0.05 * talentMeditation + 0.05 * talentReflection + HealPointsBS:GetBonus('CASTINGREG') / 100;

	local _, currentSpirit, _, _ = UnitStat("player", 5);
	local manaRegenSpirit = getRegenSpirit(currentSpirit);
	local extraNormalRegen = HealPointsBS:GetBonus('MANAREGNORMAL');
	local manaRegen5 = HealPointsBS:GetBonus('MANAREG');

	local manaRegenNormal = manaRegenSpirit + manaRegen5 + extraNormalRegen;
	local manaRegenCasting = manaRegen5 + percentRegen * (manaRegenSpirit + extraNormalRegen);

	local spiDelta = getglobal("HealPointsVariables2InputBox"):GetNumber() * (1 + HPC_ExtraSpi);
	local spiritNew = currentSpirit + spiDelta;
	local percentRegenNew = percentRegen + getglobal("HealPointsVariables6InputBox"):GetNumber() / 100;
	local manaRegen5New = manaRegen5 + getglobal("HealPointsVariables4InputBox"):GetNumber();
	local manaRegenSpiritNew = getRegenSpirit(spiritNew);

	local manaRegenNormalNew = manaRegenSpiritNew + manaRegen5New + extraNormalRegen + getglobal("HealPointsVariables5InputBox"):GetNumber();
	local manaRegenCastingNew = manaRegen5New + percentRegenNew * (manaRegenSpiritNew + extraNormalRegen + getglobal("HealPointsVariables5InputBox"):GetNumber());
	return manaRegenNormal, manaRegenCasting, manaRegenNormalNew, manaRegenCastingNew, percentRegen;
end

local function getCurrentAndNewMaxMana()
	local currentMana = UnitManaMax("player");

	local intDelta = getglobal("HealPointsVariables1InputBox"):GetNumber() * (1 + HPC_ExtraInt);
	local newMana = currentMana + (getglobal("HealPointsVariables3InputBox"):GetNumber() + 15 * intDelta) * (1 + HPC_ExtraMana);
	return currentMana, newMana;
end

local function getCurrentAndNewHealing()
	local currentHealing = HealPointsBS:GetBonus('HEAL');
	local newHealing = currentHealing + getglobal("HealPointsVariables7InputBox"):GetNumber();

	local spiritualGuidance = getTalentRank(HPC_TALENT_SPIGUI);
	local _, currentSpirit = UnitStat("player", 5);
	currentHealing = currentHealing + spiritualGuidance * 0.05 * currentSpirit;
	local newSpirit = currentSpirit + getglobal("HealPointsVariables2InputBox"):GetNumber() * (1 + HPC_ExtraSpi);
	newHealing = newHealing + spiritualGuidance * 0.05 * newSpirit;

	return currentHealing, newHealing;
end

local function getCurrentAndNewSpellCrit()
	local _, className = UnitClass("player");
	local intPerCrit = 30; -- Paladin
	if (className == "SHAMAN" or className == "DRUID") then
		intPerCrit = 40;
	elseif (className == "PRIEST") then
		intPerCrit = 50;
	end
	local _, currentIntellect, _, _ = UnitStat("player", 4);
	local talentCrit = getTalentRank(HPC_TALENT_HOLSPE) + getTalentRank(HPC_TALENT_TIDMAS) + getTalentRank(HPC_TALENT_HOLPOW);
	local buffCrit = 0;
	if (isPlayerBuffUp("Spell_Nature_MoonGlow")) then -- Moonkin aura
		buffCrit = buffCrit + 3;
	end
	if (isPlayerBuffUp("Spell_Holy_MindVision")) then -- Songflower serenade
		buffCrit = buffCrit + 5;
	end
	if (isPlayerBuffUp("INV_Misc_Head_Dragon_01")) then -- Rallying cry of the dragonslayer
		buffCrit = buffCrit + 10;
	end
	local currentSpellCrit = (currentIntellect/intPerCrit) +
	  HealPointsBS:GetBonus('SPELLCRIT') +
	  HealPointsBS:GetBonus('HOLYCRIT') +
	  HealPointsBS:GetBonus('NATURECRIT') +
	  talentCrit + buffCrit;

	local intDelta = getglobal("HealPointsVariables1InputBox"):GetNumber();
	intDelta = intDelta + HPC_ExtraInt * intDelta;
	local newSpellCrit = currentSpellCrit + getglobal("HealPointsVariables8InputBox"):GetNumber() + intDelta / intPerCrit;
	return currentSpellCrit, newSpellCrit;
end

-- Update functions
local function updateSpellLists() 	-- Update dropdown menus 
	local function updateSpellList(objref, spellTable)
		if (spellTable) then
			local count = 0;
			for i = 1, table.getn(spellTable), 1 do
				if (getHighestSpellRank(spellTable[i]['name']) >= spellTable[i]['rank']) then
					info = {};
					info.text = spellTable[i]['abbr'].." ("..spellTable[i]['rank']..")";
					info.func = HealPointsCalculatorDropDown_OnClick;
					if (objref and type(objref) == "table") then
						info.owner = objref;
					end
					UIDropDownMenu_AddButton(info)
					count = count + 1;
				end
			end
			if (UIDropDownMenu_GetSelectedID(objref) == nil) then
				UIDropDownMenu_SetSelectedID(objref, count);
			end
		end
	end

	UIDropDownMenu_Initialize(HealPointsSpellShort,function() updateSpellList(HealPointsSpellShort, SPELLTABLE[1]); end);
	UIDropDownMenu_Initialize(HealPointsSpellLong,function() updateSpellList(HealPointsSpellLong, SPELLTABLE[2]); end);
	UIDropDownMenu_Initialize(HealPointsSpellHOT,function() updateSpellList(HealPointsSpellHOT, SPELLTABLE[3]); end);
end

local function updateSpellTable() 	-- Update tables with info about currently selected spellrank 
	if (UIDropDownMenu_GetSelectedID(HealPointsSpellLong) == nil) then -- should not happen
		updateSpellLists()
	end
	
	SELECTED = { };
	local selectedRank = { };
	selectedRank[1] = UIDropDownMenu_GetSelectedID(HealPointsSpellShort);
	selectedRank[2] = UIDropDownMenu_GetSelectedID(HealPointsSpellLong);
	selectedRank[3] = UIDropDownMenu_GetSelectedID(HealPointsSpellHOT);	
	
	for i = 1, 3 do
		if (selectedRank[i] and SPELLTABLE[i] ~= nil) then
			SELECTED[i] = SPELLTABLE[i][selectedRank[i]];
		end
	end
	
	SELECTED[2], SELECTED[1], SELECTED[3] = updateSpellTalents(SELECTED[2], SELECTED[1], SELECTED[3]);
end	
	
local function updateStats() 		-- Update stats (int, spi, regen, ...)																				
	local function setStatInfo(number, name, currentStat, extraDelta, numberFormat)
		local frame = getglobal("HealPointsVariables"..number);
		local label = getglobal(frame:GetName().."Label");
		local originalStatText = getglobal(frame:GetName().."OriginalStat");
		local inputBox = getglobal(frame:GetName().."InputBox");
		local newStatText = getglobal(frame:GetName().."NewStat");
		
		local delta = inputBox:GetNumber() + extraDelta;
		local newStat = currentStat + delta;
		label:SetText(name);
		if (numberFormat) then
			currentStat = format(numberFormat, currentStat);
			newStat = format(numberFormat, newStat);
		end
		originalStatText:SetText(currentStat);
		setStat(newStatText, newStat, delta);
	end

	-- Intellect
	local _, currentIntellect, _, _ = UnitStat("player", 4);
	local intDelta = getglobal("HealPointsVariables1InputBox"):GetNumber();
	local extraInt = HPC_ExtraInt * intDelta;
	setStatInfo(1, "Intellect:", currentIntellect, extraInt, "%5.0f");
	intDelta = intDelta + extraInt;
	
	-- Spirit
	local _, currentSpirit, _, _ = UnitStat("player", 5);
	local extraSpi = HPC_ExtraSpi * getglobal("HealPointsVariables2InputBox"):GetNumber();
	setStatInfo(2, "Spirit:", currentSpirit, extraSpi, "%5.0f");

	-- Max mana															
	local currentMana = UnitManaMax("player");
	local extraMana = HPC_ExtraMana * (getglobal("HealPointsVariables3InputBox"):GetNumber() + 15 * intDelta);
	setStatInfo(3, "Max mana:", currentMana, 15 * intDelta + extraMana, "%5.0f");
	
	-- Mana regen (casting, normal, %casting)
	local manaRegenNormal, manaRegenCasting, manaRegenNormalNew, manaRegenCastingNew, percentRegen = getCurrentAndNewManaRegen();
	local manaRegenCastingDelta = manaRegenCastingNew - manaRegenCasting - getglobal("HealPointsVariables4InputBox"):GetNumber();
	local manaRegenNormalDelta = manaRegenNormalNew - manaRegenNormal - getglobal("HealPointsVariables5InputBox"):GetNumber();
	
	setStatInfo(4, "Casting regen/5s:", manaRegenCasting, manaRegenCastingDelta, "%5.0f");
	setStatInfo(5, "Normal regen/5s:", manaRegenNormal, manaRegenNormalDelta, "%5.0f");
	setStatInfo(6, "% regen while casting:", 100 * percentRegen, 0, "%5.0f");
	
	-- +Healing
	local currentHealing, newHealing = getCurrentAndNewHealing();
	setStatInfo(7, "+Healing:", currentHealing, newHealing - currentHealing - getglobal("HealPointsVariables7InputBox"):GetNumber());
	
	-- Spell crit														
	local currentSpellCrit, newSpellCrit = getCurrentAndNewSpellCrit();
	setStatInfo(8, "Healing spell crit(%):", currentSpellCrit, newSpellCrit - currentSpellCrit - getglobal("HealPointsVariables8InputBox"):GetNumber(), "%1.2f");
end

local function updateSpellStats() 	-- Update derived stats about selected spellranks 
	local function setSpellInfo(number, spellType, oldVal, newVal, formatString)
		if (newVal < 0) then
			newVal = GREEN_FONT_COLOR_CODE.."Infinite"..FONT_COLOR_CODE_CLOSE;
		elseif (newVal > oldVal) then
			newVal = GREEN_FONT_COLOR_CODE..format(formatString,newVal)..FONT_COLOR_CODE_CLOSE;
		elseif (newVal < oldVal) then
			newVal = RED_FONT_COLOR_CODE..format(formatString,newVal)..FONT_COLOR_CODE_CLOSE;
		else
			newVal = format(formatString,newVal);
		end
		local spellString = getglobal("HealPointsSpell"..number..spellType);
		if (oldVal < 0) then
			spellString:SetText(newVal.."(Infinite)");
		else
			spellString:SetText(format("%s("..formatString..")", newVal, oldVal));
		end
	end

	local _, manaRegenCasting, _, manaRegenCastingNew = getCurrentAndNewManaRegen();
	local currentMana, newMana = getCurrentAndNewMaxMana();
	local currentHealing, newHealing = getCurrentAndNewHealing();
	local currentSpellCrit, newSpellCrit = getCurrentAndNewSpellCrit();	

	local spellString = { "Short", "Long", "HOT" }; -- GUI-related
	
	-- HP/s
	getglobal("HealPointsSpell1Label"):SetText("HP/s:");

	local oldHPSec = { };
	local newHPSec = { };
	for i = 1, 3 do
		if (SELECTED[i] ~= nil) then
			oldHPSec[i] = getHPSec(SELECTED[i], currentHealing, currentSpellCrit);
			newHPSec[i] = getHPSec(SELECTED[i], newHealing, newSpellCrit);
			setSpellInfo(1, spellString[i], oldHPSec[i], newHPSec[i], "%d");
		end
	end
	
	-- HP/mana
	getglobal("HealPointsSpell2Label"):SetText("HP/mana:");

	local oldHPMana = { };
	local newHPMana = { };
	for i = 1, 3 do
		if (SELECTED[i] ~= nil) then
			oldHPMana[i] = getHPMana(SELECTED[i], currentHealing, currentSpellCrit);
			newHPMana[i] = getHPMana(SELECTED[i], newHealing, newSpellCrit);
			setSpellInfo(2, spellString[i], oldHPMana[i], newHPMana[i], "%1.1f");
		end
	end
	
	-- HP/cast
	getglobal("HealPointsSpell3Label"):SetText("HP/cast:");
	for i = 1, 3 do 
		if (SELECTED[i] ~= nil) then
			local oldHPCast, newHPCast;
			if (SELECTED[i]['type'] == 'regrowth') then
				oldHPCast = oldHPSec[i] * (SELECTED[i]['time'] + SELECTED[i]['hottime']);
				newHPCast = newHPSec[i] * (SELECTED[i]['time'] + SELECTED[i]['hottime']);
			else
				oldHPCast = oldHPSec[i] * SELECTED[i]['time'];
				newHPCast = newHPSec[i] * SELECTED[i]['time'];
			end
			setSpellInfo(3, spellString[i], oldHPCast, newHPCast, "%d");
		end
	end
	
	-- Max heal (no regen)
	getglobal("HealPointsSpell4Label"):SetText("Tot HP (-r):");

	for i = 1, 3 do 
		if (SELECTED[i] ~= nil) then
			local oldHPTotal = getHPTotal(oldHPMana[i], currentMana);
			local newHPTotal = getHPTotal(newHPMana[i], newMana);
			setSpellInfo(4, spellString[i], oldHPTotal, newHPTotal, "%d");
		end	
	end
	
	-- Max heal (regen)
	getglobal("HealPointsSpell5Label"):SetText("Tot HP (+r):");

	for i = 1, 3 do 
		if (SELECTED[i] ~= nil) then
			local oldHPTotalRegen, t1 = getHPTotalRegen(SELECTED[i], currentHealing, currentSpellCrit, manaRegenCasting, currentMana);
			local newHPTotalRegen, t2 = getHPTotalRegen(SELECTED[i], newHealing, newSpellCrit, manaRegenCastingNew, newMana);
			TH_TotalTimeCurrent[i] = t1;
			TH_TotalTimeNew[i] = t2;
			setSpellInfo(5, spellString[i], oldHPTotalRegen, newHPTotalRegen, "%d");
		end	
	end
end

local function updateHealPoints() 	-- Update the healpoints statistic																					
	local function setResultInfo(number, name, currentStat, newStat, numberFormat)
		local frame = getglobal("HealPointsResult"..number);
		local label = getglobal(frame:GetName().."Label");
		local current = getglobal(frame:GetName().."Current");
		local delta = getglobal(frame:GetName().."Difference");
		local new = getglobal(frame:GetName().."Result");
	
		local deltaStat = newStat - currentStat;
		local deltaText = deltaStat;
		label:SetText(name);
		if (numberFormat) then
			currentStat = format(numberFormat, currentStat);
			newStat = format(numberFormat, newStat);
			deltaText = format(numberFormat, deltaText);
		end
		current:SetText(currentStat);
		setStat(delta, deltaText, deltaStat);
		setStat(new, newStat, deltaStat);
	end

	local manaRegenNormal, manaRegenCasting, manaRegenNormalNew, manaRegenCastingNew = getCurrentAndNewManaRegen();
	local currentMana, newMana = getCurrentAndNewMaxMana();
	local currentHealing, newHealing = getCurrentAndNewHealing();
	local currentSpellCrit, newSpellCrit = getCurrentAndNewSpellCrit();	
	
	local healPointsCurrent, healedPowerful, healedEfficient, regenInMin, powerfulCurrent, efficientCurrent = 
		HealPointsCalculator_ComputeHealpoints(currentHealing, currentSpellCrit, currentMana, manaRegenCasting, manaRegenNormal);
	
	local healPointsNew, healedPowerfulNew, healedEfficientNew, regenInMinNew, powerfulNew, efficientNew = 
		HealPointsCalculator_ComputeHealpoints(newHealing, newSpellCrit, newMana, manaRegenCastingNew, manaRegenNormalNew);
	
	HP_LastPowerfulCurrent = powerfulCurrent;
	HP_LastPowerfulNew = powerfulNew;
	HP_LastEfficientCurrent = efficientCurrent;
	HP_LastEfficientNew = efficientNew;
	
	setResultInfo(1, "PowerPoints:", healedPowerful, healedPowerfulNew, "%5.0f");
	setResultInfo(2, "+ EndurancePoints:", healedEfficient, healedEfficientNew, "%5.0f");
	setResultInfo(3, "+ RegenPoints:", regenInMin, regenInMinNew, "%5.0f");
	setResultInfo(4, "= HealPoints:", healPointsCurrent, healPointsNew, "%5.0f");
end

-- Global functions
function HealPointsCalculator_ComputeHealpoints(healing, spellCrit, maxMana, manaRegenCasting, manaRegenNormal)
	local manaRegainOnCrit = 0.20 * getTalentRank(HPC_TALENT_ILLUMI);
	local manaRegainFactor = 1 - (spellCrit / 100) * manaRegainOnCrit;
	local powerPoints, powerfulSpell = computePowerPoints(healing, spellCrit, maxMana, manaRegenCasting, manaRegenNormal, manaRegainFactor);
	local endurancePoints, efficientSpell = computeEndurancePoints(healing, spellCrit, manaRegenCasting, manaRegenNormal, manaRegainFactor);
	
	-- Mana regen in 3 min
	local regenPoints = manaRegenNormal * 36;
	
	-- Healpoints
	local healPoints = powerPoints + endurancePoints + regenPoints;

	return healPoints, powerPoints, endurancePoints, regenPoints, powerfulSpell, efficientSpell;
end

function HealPointsCalculator_ComputeManaRegen()																										
	local manaRegenNormal, manaRegenCasting = getCurrentAndNewManaRegen();
	return manaRegenNormal, manaRegenCasting;
end

function HealPointsCalculator_ComputeHealing()
	local currentHealing = getCurrentAndNewHealing();
	return currentHealing;
end

function HealPointsCalculator_ComputeSpellCrit()																										
	local currentSpellCrit = getCurrentAndNewSpellCrit();
	return currentSpellCrit;
end

-- Event functions				
function HealPointsCalculator_OnLoad() 
	tinsert(UISpecialFrames, "HealPointsCalculator"); -- Esc closes the window
	UIPanelWindows["HealPointsCalculator"] = nil;
	
	-- Register events
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("UNIT_LEVEL");
	this:RegisterEvent("UNIT_MAXMANA");
	this:RegisterEvent("UNIT_STATS");
	this:RegisterEvent("LEARNED_SPELL_IN_TAB");
	this:RegisterEvent("CHARACTER_POINTS_CHANGED");

	local _, className = UnitClass("player");
	if (className == "PALADIN") then
		SPELLTABLE[1] = Paladin_Fast;
		SPELLTABLE[2] = Paladin_Slow;
    SPELLTABLE[3] = Paladin_Instant;
    getglobal("HealPointsCalculatorBoL"):SetChecked(1);
	elseif (className == "PRIEST") then
		SPELLTABLE[1] = Priest_Fast;
		SPELLTABLE[2] = Priest_Slow;
		SPELLTABLE[3] = Priest_Hot;
		getglobal("HealPointsCalculatorBoL"):Hide();
		getglobal("HealPointsCalculatorBoLText"):Hide();
	elseif (className == "DRUID") then
		SPELLTABLE[1] = Druid_Fast;
		SPELLTABLE[2] = Druid_Slow;
		SPELLTABLE[3] = Druid_Hot;
		getglobal("HealPointsCalculatorBoL"):Hide();
		getglobal("HealPointsCalculatorBoLText"):Hide();
	elseif (className == "SHAMAN") then
		SPELLTABLE[1] = Shaman_Fast;
		SPELLTABLE[2] = Shaman_Slow;
		SPELLTABLE[3] = Shaman_Chain;
		getglobal("HealPointsCalculatorBoL"):Hide();
		getglobal("HealPointsCalculatorBoLText"):Hide();
	end
	local _, raceName = UnitRace("player");
	if (raceName == "Human") then
		HPC_ExtraSpi = 0.05;
	end
	
	local oldFunc = HealPointsBS_Update;
	HealPointsBS_Update = function () 
		if (HealPointsCalculator:IsVisible()) then
			updateSpellTable();
			updateStats(); 
			updateSpellStats(); 
			updateHealPoints(); 
		end
		oldFunc(); 
	end
end

function HealPointsCalculator_OnEvent(event)
	local function printActiveBuffs()
	  local iIterator = 1
	  while (UnitBuff("player", iIterator)) do
		DEFAULT_CHAT_FRAME:AddMessage("Buff: "..UnitBuff("player", iIterator),1,1,1);
		iIterator = iIterator + 1
	  end
	end

	--printActiveBuffs();
	if (event == "LEARNED_SPELL_IN_TAB" or event == "CHARACTER_POINTS_CHANGED") then
		updateSpellLists();
		updateSpellTable();
	end
	-- Do nothing if Calculator frame is not visable
	if (not HealPointsCalculator:IsVisible()) then
		return;
	end
	-- Do nothing if event target is not player
	if ((	event == "UNIT_AURA" or 
			event == "UNIT_LEVEL" or 
			event == "UNIT_MAXMANA" or 
			event == "UNIT_STATS") 
			and not UnitIsUnit(arg1, "player")) then
		return;
	end	
	updateStats();
	updateSpellStats();
	updateHealPoints();
end

function HealPointsCalculator_OnShow()
	if (SELECTED[2]	== nil) then
		updateSpellLists();
		updateSpellTable();	
	end
	updateStats();
	updateSpellStats();
	updateHealPoints();
end

function HealPointsCalculator_OnEnter()
	local function spellToString(spell)
		return spell['name'].." ("..spell['rank']..")";
	end

	local function totalTimeToString(curTime, newTime)
		if (curTime == null) then
			curTime = "NA";
		elseif (curTime < 0) then
			curTime = "Infinite";
		else
			curTime = format("%d", curTime).."s";
		end
		if (newTime == null) then
			newTime = "NA";
		elseif (newTime < 0) then
			newTime = "Infinite";
		else
			newTime = format("%d", newTime).."s";
		end
		return newTime.." ("..curTime..")";
	end
	
	GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
	if (this:GetID() == 1) then	-- PowerPoints
		GameTooltip:SetText("PowerPoints", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Hitpoints healed in 1 minute using your most");
		GameTooltip:AddLine("powerful spell, starting with full mana bar.");
		GameTooltip:AddLine("Regeneration and 5 sec rule are taken into account.");
		GameTooltip:AddLine("\nMost powerful spell:", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine(spellToString(HP_LastPowerfulCurrent).." / "..spellToString(HP_LastPowerfulNew));
	elseif (this:GetID() == 2) then -- EndurancePoints
		GameTooltip:SetText("EndurancePoints", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Hitpoints healed in 5 minutes using your most");
		GameTooltip:AddLine("efficient spell, starting with empty mana bar.");
		GameTooltip:AddLine("Regeneration and 5 sec rule are taken into account.");
		GameTooltip:AddLine("\nMost efficient spell:", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine(spellToString(HP_LastEfficientCurrent).." / "..spellToString(HP_LastEfficientNew));
	elseif (this:GetID() == 3) then -- RegenPoints
		GameTooltip:SetText("RegenPoints", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Mana regenerated in 3 minutes");
		GameTooltip:AddLine("using normal regen.");
	elseif (this:GetID() == 8) then -- Tot. healed without regen
		GameTooltip:SetText("Total hitpoints healed (no regen)", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Hitpoints healed with selected spell");
		GameTooltip:AddLine("using the whole mana bar.");
		GameTooltip:AddLine("Regeneration not taken into account.");
	elseif (this:GetID() == 9) then -- Tot. healed with regen
		GameTooltip:SetText("Total hitpoints healed (regen)", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Hitpoints healed with selected spell");
		GameTooltip:AddLine("using the whole mana bar.");
		GameTooltip:AddLine("Casting regeneration is taken into account.");
		GameTooltip:AddLine("\nTime taken until mana bar is spent:", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine(totalTimeToString(TH_TotalTimeCurrent[1], TH_TotalTimeNew[1]).."    "..
							totalTimeToString(TH_TotalTimeCurrent[2], TH_TotalTimeNew[2]).."    "..
							totalTimeToString(TH_TotalTimeCurrent[3], TH_TotalTimeNew[3]));
	elseif (this:GetID() == 13) then -- Casting regen
		GameTooltip:SetText("Casting mana regeneration", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Mana regenerated when last spell");
		GameTooltip:AddLine("was casted less than 5 seconds ago.");
	elseif (this:GetID() == 14) then -- Normal regen
		GameTooltip:SetText("Normal mana regeneration", HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddLine("Mana regenerated when last spell");
		GameTooltip:AddLine("was casted more than 5 seconds ago.");
	end
	GameTooltip:Show();
end

function HealPointsCalculator_OnLeave()
	GameTooltip:Hide();
end

function HealPointsCalculator_OnMouseDown(arg1)
	if (arg1=="LeftButton") then
		HealPointsCalculator:StartMoving();
	end
end

function HealPointsCalculator_OnMouseUp(arg1)
	if (arg1=="LeftButton") then
		HealPointsCalculator:StopMovingOrSizing();
	end
end

function HealPointsCalculatorDropDown_OnClick()
	if (this.owner) then
		UIDropDownMenu_SetSelectedID(this.owner, this:GetID());
		updateSpellTable();
		updateSpellStats();
	end
end

function HealPointsCalculatorReset_OnClick()
	for i = 1, 8, 1 do
		local frame = getglobal("HealPointsVariables"..i);
		local inputBox = getglobal("HealPointsVariables"..i.."InputBox");
		inputBox:SetText("0");
		inputBox:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	end
end

function HealPointsCalculatorBoL_OnClick()
	updateSpellStats();
	updateHealPoints();
end

function HealPointsIncrement_OnClick()
	local inputBox = getglobal(strsub(this:GetName(), 1, -16).."InputBox");
	inputBox:SetNumber(inputBox:GetNumber() + 1);
	inputBox:ClearFocus();
end

function HealPointsDecrement_OnClick()
	local inputBox = getglobal(strsub(this:GetName(), 1, -16).."InputBox");
	inputBox:SetNumber(inputBox:GetNumber() - 1);
	inputBox:ClearFocus();
end

function HealPointsInputBox_OnTextChanged()
	local inputBox = getglobal(this:GetName());
	if (inputBox:GetNumber() > 0) then
		inputBox:SetTextColor(GREEN_FONT_COLOR.r, GREEN_FONT_COLOR.g, GREEN_FONT_COLOR.b);
	elseif (inputBox:GetNumber() < 0) then
		inputBox:SetTextColor(RED_FONT_COLOR.r, RED_FONT_COLOR.g, RED_FONT_COLOR.b);
	else
		inputBox:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	end
	updateStats();
	updateSpellStats();
	updateHealPoints();
end

